#include <vector>
#include <math.h>
#include <iostream>
#include <conio.h>
using namespace std;
int main(){
	size_t i, j;
	size_t number_count;
	cerr << "Enter number count: ";
	cin >> number_count;
	vector<double> numbers(number_count);
	cerr << "Enter numbers: ";
	for (i = 0; i < number_count; i++){
		cin >> numbers[i];
	}
	size_t bin_count;
	cerr << "Enter bin count: ";
	cin >> bin_count;
	vector<size_t> bins(bin_count);
	double min = numbers[0];
	double max = numbers[0];
	for (double x : numbers){
		if (x < min){
			min = x;
		}
		else if (x > max){
            max = x;
		}
	}
	double bin_size = (max - min) / bin_count;
	for (i = 0; i < number_count; i++){
		bool found = false;
		for (j = 0; (j < bin_count - 1) && !found; j++){
			auto lo = min + j * bin_size;
			auto hi = min + (j + 1) * bin_size;
			if ((lo <= numbers[i]) && (numbers[i] < hi)){
				bins[j]++;
				found = true;
			}
		}
		if (!found){
			bins[bin_count - 1]++;
		}
	}
	vector<size_t> counts(bin_count);
	for (i = 0; i < bin_count; i++){
		for (j = 0; j < bins[i]; j++){
			counts[i]++;
		}
	}
	size_t max_count = counts[0];
	for (i=0; i<bin_count; i++){
        if(counts[i]>max_count){
            max_count = counts[i];
        }
	}
	const size_t screen_width = 80;
	const size_t max_asterisk = screen_width - 3 - 1;
	vector<size_t> heights(bin_count);
	size_t height;
	for (i=0; i<bin_count; i++){
            if (max_count > 76){
                height = (max_asterisk*(static_cast<double>(counts[i])/max_count));
            }
                else {
                    height = counts[i];
                }
            heights[i] = height;
	}
        for (i = 0; i < bin_count; i++){
            if(bins[i]<100){
                cout << " ";
            }
            if (bins[i]<10){
                cout << " ";
            }
		cout << bins[i] << "|";
		for (j = 0; j < heights[i]; j++){
			cout << "*";
		}
		cout << "\n";
	}
	getch();
	return 0;
}
